(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/NewScript/node-test.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'cbb2fZZTDdKkaLlF69WfuIy', 'node-test', __filename);
// NewScript/node-test.ts

Object.defineProperty(exports, "__esModule", { value: true });
var ccclass = cc._decorator.ccclass;
var NodeTestComponent = /** @class */ (function (_super) {
    __extends(NodeTestComponent, _super);
    function NodeTestComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    NodeTestComponent.prototype.start = function () {
        var grandParent = new cc.Node('GrandParent');
        this.node.addChild(grandParent);
        var parent = new cc.Node('Parent');
        grandParent.addChild(parent);
        var child = new cc.Node('Child');
        parent.addChild(child);
        var child2 = new cc.Node('Child2');
        parent.addChild(child2);
        var child3 = new cc.Node('Child3');
        parent.addChild(child3);
        grandParent.anchorX = 0.5;
        grandParent.anchorY = 0.5;
        grandParent.width = 800;
        grandParent.height = 500;
        parent.anchorX = 0.5;
        parent.anchorY = 0.5;
        parent.width = 500;
        parent.height = 300;
        child.anchorX = 0.5;
        child.anchorY = 0.5;
        child.width = 100;
        child.height = 100;
        child2.anchorX = 0.5;
        child2.anchorY = 0.5;
        child2.width = 100;
        child2.height = 100;
        child3.anchorX = 0.5;
        child3.anchorY = 0.5;
        child3.width = 100;
        child3.height = 100;
        var nodeActions = [{
                node: grandParent,
                action: cc.moveBy(0, cc.v2(-50, 0))
            }, {
                node: parent,
                action: cc.moveBy(0, cc.v2(-150, 0))
            }
        ];
        parent.children.forEach(function (c, index) {
            nodeActions.push({
                node: c,
                action: cc.moveBy(0, cc.v2(100 * index, 0))
            });
        });
        // Run all Moving actions that are collected in the array at once
        nodeActions.forEach(function (item) { return item.node.runAction(item.action); });
        setTimeout(function () {
            var debugNodes = [
                { node: grandParent, color: cc.Color.RED, lineWidth: 10 },
                { node: parent, color: cc.Color.GREEN, lineWidth: 5 },
                { node: child, color: cc.Color.BLUE, lineWidth: 3 },
                { node: child2, color: cc.Color.CYAN, lineWidth: 3 },
                { node: child3, color: cc.Color.YELLOW, lineWidth: 3 },
            ];
            debugNodes.forEach(function (curr) {
                var drawing = curr.node.addComponent(cc.Graphics);
                drawing.rect(curr.node.x, curr.node.y, curr.node.width, curr.node.height);
                drawing.lineWidth = curr.lineWidth;
                drawing.strokeColor = curr.color;
                drawing.stroke();
            });
        }, 10); // If you run with 0ms timeout it actually works!
    };
    NodeTestComponent = __decorate([
        ccclass
    ], NodeTestComponent);
    return NodeTestComponent;
}(cc.Component));
exports.default = NodeTestComponent;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=node-test.js.map
        